=begin
#NSX API

#VMware NSX REST API

OpenAPI spec version: 1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.3.1

=end

require 'date'

module NSXT
  # AWS account status
  class AwsAccountStatus
    attr_accessor :_self

    # The server will populate this field when returing the resource. Ignored on PUT and POST.
    attr_accessor :_links

    attr_accessor :_schema

    # State of inventory sync
    attr_accessor :inventory_sync_step

    # State of inventory sync
    attr_accessor :inventory_sync_status

    # Status of the account credentials synched at the auto interval
    attr_accessor :credentials_status

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'_self' => :'_self',
        :'_links' => :'_links',
        :'_schema' => :'_schema',
        :'inventory_sync_step' => :'inventory_sync_step',
        :'inventory_sync_status' => :'inventory_sync_status',
        :'credentials_status' => :'credentials_status'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'_self' => :'SelfResourceLink',
        :'_links' => :'Array<ResourceLink>',
        :'_schema' => :'String',
        :'inventory_sync_step' => :'String',
        :'inventory_sync_status' => :'String',
        :'credentials_status' => :'String'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}){|(k,v), h| h[k.to_sym] = v}

      if attributes.has_key?(:'_self')
        self._self = attributes[:'_self']
      end

      if attributes.has_key?(:'_links')
        if (value = attributes[:'_links']).is_a?(Array)
          self._links = value
        end
      end

      if attributes.has_key?(:'_schema')
        self._schema = attributes[:'_schema']
      end

      if attributes.has_key?(:'inventory_sync_step')
        self.inventory_sync_step = attributes[:'inventory_sync_step']
      end

      if attributes.has_key?(:'inventory_sync_status')
        self.inventory_sync_status = attributes[:'inventory_sync_status']
      end

      if attributes.has_key?(:'credentials_status')
        self.credentials_status = attributes[:'credentials_status']
      end

    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      return invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      inventory_sync_step_validator = EnumAttributeValidator.new('String', ["SYNCING_AWS_REGIONS", "SYNCING_AWS_VPCS", "SYNCING_AWS_AZS", "SYNCING_VMS", "SYNCING_NSX_DATA", "SYNCING_AWS_GATEWAYS", "SYNCING_MANAGED_INSTANCES", "NOT_APPLICABLE"])
      return false unless inventory_sync_step_validator.valid?(@inventory_sync_step)
      inventory_sync_status_validator = EnumAttributeValidator.new('String', ["SYNCED", "IN_PROGRESS"])
      return false unless inventory_sync_status_validator.valid?(@inventory_sync_status)
      credentials_status_validator = EnumAttributeValidator.new('String', ["VALID", "INVALID"])
      return false unless credentials_status_validator.valid?(@credentials_status)
      return true
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] inventory_sync_step Object to be assigned
    def inventory_sync_step=(inventory_sync_step)
      validator = EnumAttributeValidator.new('String', ["SYNCING_AWS_REGIONS", "SYNCING_AWS_VPCS", "SYNCING_AWS_AZS", "SYNCING_VMS", "SYNCING_NSX_DATA", "SYNCING_AWS_GATEWAYS", "SYNCING_MANAGED_INSTANCES", "NOT_APPLICABLE"])
      unless validator.valid?(inventory_sync_step)
        fail ArgumentError, "invalid value for 'inventory_sync_step', must be one of #{validator.allowable_values}."
      end
      @inventory_sync_step = inventory_sync_step
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] inventory_sync_status Object to be assigned
    def inventory_sync_status=(inventory_sync_status)
      validator = EnumAttributeValidator.new('String', ["SYNCED", "IN_PROGRESS"])
      unless validator.valid?(inventory_sync_status)
        fail ArgumentError, "invalid value for 'inventory_sync_status', must be one of #{validator.allowable_values}."
      end
      @inventory_sync_status = inventory_sync_status
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] credentials_status Object to be assigned
    def credentials_status=(credentials_status)
      validator = EnumAttributeValidator.new('String', ["VALID", "INVALID"])
      unless validator.valid?(credentials_status)
        fail ArgumentError, "invalid value for 'credentials_status', must be one of #{validator.allowable_values}."
      end
      @credentials_status = credentials_status
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          _self == o._self &&
          _links == o._links &&
          _schema == o._schema &&
          inventory_sync_step == o.inventory_sync_step &&
          inventory_sync_status == o.inventory_sync_status &&
          credentials_status == o.credentials_status
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [_self, _links, _schema, inventory_sync_step, inventory_sync_status, credentials_status].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map{ |v| _deserialize($1, v) } )
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = NSXT.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map{ |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end

end
