=begin
#NSX API

#VMware NSX REST API

OpenAPI spec version: 1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.3.1

=end

require 'date'

module NSXT
  # Aws gateway configuration
  class AwsGatewayConfig
    attr_accessor :_self

    # The server will populate this field when returing the resource. Ignored on PUT and POST.
    attr_accessor :_links

    attr_accessor :_schema

    # The ID of the Amazon Machine Image on which this gateway resides 
    attr_accessor :ami_id

    # Determines if connection to NSX Manager is via public IP or private IP 
    attr_accessor :nsx_manager_connection

    # Aws Gateway HA configuration
    attr_accessor :gateway_ha_configuration

    # Flag to identify if HA is enabled
    attr_accessor :is_ha_enabled

    # Flag to identify if default quarantine policy is enabled
    attr_accessor :default_quarantine_policy_enabled

    # The key pair name required to authenticate into any instance
    attr_accessor :key_pair_name

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'_self' => :'_self',
        :'_links' => :'_links',
        :'_schema' => :'_schema',
        :'ami_id' => :'ami_id',
        :'nsx_manager_connection' => :'nsx_manager_connection',
        :'gateway_ha_configuration' => :'gateway_ha_configuration',
        :'is_ha_enabled' => :'is_ha_enabled',
        :'default_quarantine_policy_enabled' => :'default_quarantine_policy_enabled',
        :'key_pair_name' => :'key_pair_name'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'_self' => :'SelfResourceLink',
        :'_links' => :'Array<ResourceLink>',
        :'_schema' => :'String',
        :'ami_id' => :'String',
        :'nsx_manager_connection' => :'String',
        :'gateway_ha_configuration' => :'Array<AwsGatewayHaConfig>',
        :'is_ha_enabled' => :'BOOLEAN',
        :'default_quarantine_policy_enabled' => :'BOOLEAN',
        :'key_pair_name' => :'String'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}){|(k,v), h| h[k.to_sym] = v}

      if attributes.has_key?(:'_self')
        self._self = attributes[:'_self']
      end

      if attributes.has_key?(:'_links')
        if (value = attributes[:'_links']).is_a?(Array)
          self._links = value
        end
      end

      if attributes.has_key?(:'_schema')
        self._schema = attributes[:'_schema']
      end

      if attributes.has_key?(:'ami_id')
        self.ami_id = attributes[:'ami_id']
      end

      if attributes.has_key?(:'nsx_manager_connection')
        self.nsx_manager_connection = attributes[:'nsx_manager_connection']
      end

      if attributes.has_key?(:'gateway_ha_configuration')
        if (value = attributes[:'gateway_ha_configuration']).is_a?(Array)
          self.gateway_ha_configuration = value
        end
      end

      if attributes.has_key?(:'is_ha_enabled')
        self.is_ha_enabled = attributes[:'is_ha_enabled']
      end

      if attributes.has_key?(:'default_quarantine_policy_enabled')
        self.default_quarantine_policy_enabled = attributes[:'default_quarantine_policy_enabled']
      end

      if attributes.has_key?(:'key_pair_name')
        self.key_pair_name = attributes[:'key_pair_name']
      end

    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      return invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      nsx_manager_connection_validator = EnumAttributeValidator.new('String', ["PUBLIC_IP", "PRIVATE_IP"])
      return false unless nsx_manager_connection_validator.valid?(@nsx_manager_connection)
      return true
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] nsx_manager_connection Object to be assigned
    def nsx_manager_connection=(nsx_manager_connection)
      validator = EnumAttributeValidator.new('String', ["PUBLIC_IP", "PRIVATE_IP"])
      unless validator.valid?(nsx_manager_connection)
        fail ArgumentError, "invalid value for 'nsx_manager_connection', must be one of #{validator.allowable_values}."
      end
      @nsx_manager_connection = nsx_manager_connection
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          _self == o._self &&
          _links == o._links &&
          _schema == o._schema &&
          ami_id == o.ami_id &&
          nsx_manager_connection == o.nsx_manager_connection &&
          gateway_ha_configuration == o.gateway_ha_configuration &&
          is_ha_enabled == o.is_ha_enabled &&
          default_quarantine_policy_enabled == o.default_quarantine_policy_enabled &&
          key_pair_name == o.key_pair_name
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [_self, _links, _schema, ami_id, nsx_manager_connection, gateway_ha_configuration, is_ha_enabled, default_quarantine_policy_enabled, key_pair_name].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map{ |v| _deserialize($1, v) } )
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = NSXT.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map{ |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end

end
