=begin
#NSX API

#VMware NSX REST API

OpenAPI spec version: 1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.3.1

=end

require 'date'

module NSXT
  # Aws subnet configuration to deploy gateways
  class AwsGatewayHaConfig
    attr_accessor :_self

    # The server will populate this field when returing the resource. Ignored on PUT and POST.
    attr_accessor :_links

    attr_accessor :_schema

    # Index of HA that indicates whether gateway is primary or secondary. If index is 0, then it is primary gateway. Else secondary gateway. 
    attr_accessor :gateway_ha_index

    # Management subnet
    attr_accessor :management_subnet

    # Downlink subnet
    attr_accessor :downlink_subnet

    # Uplink subnet
    attr_accessor :uplink_subnet

    # Availability Zone
    attr_accessor :availability_zone


    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'_self' => :'_self',
        :'_links' => :'_links',
        :'_schema' => :'_schema',
        :'gateway_ha_index' => :'gateway_ha_index',
        :'management_subnet' => :'management_subnet',
        :'downlink_subnet' => :'downlink_subnet',
        :'uplink_subnet' => :'uplink_subnet',
        :'availability_zone' => :'availability_zone'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'_self' => :'SelfResourceLink',
        :'_links' => :'Array<ResourceLink>',
        :'_schema' => :'String',
        :'gateway_ha_index' => :'Integer',
        :'management_subnet' => :'String',
        :'downlink_subnet' => :'String',
        :'uplink_subnet' => :'String',
        :'availability_zone' => :'String'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}){|(k,v), h| h[k.to_sym] = v}

      if attributes.has_key?(:'_self')
        self._self = attributes[:'_self']
      end

      if attributes.has_key?(:'_links')
        if (value = attributes[:'_links']).is_a?(Array)
          self._links = value
        end
      end

      if attributes.has_key?(:'_schema')
        self._schema = attributes[:'_schema']
      end

      if attributes.has_key?(:'gateway_ha_index')
        self.gateway_ha_index = attributes[:'gateway_ha_index']
      end

      if attributes.has_key?(:'management_subnet')
        self.management_subnet = attributes[:'management_subnet']
      end

      if attributes.has_key?(:'downlink_subnet')
        self.downlink_subnet = attributes[:'downlink_subnet']
      end

      if attributes.has_key?(:'uplink_subnet')
        self.uplink_subnet = attributes[:'uplink_subnet']
      end

      if attributes.has_key?(:'availability_zone')
        self.availability_zone = attributes[:'availability_zone']
      end

    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @gateway_ha_index.nil?
        invalid_properties.push("invalid value for 'gateway_ha_index', gateway_ha_index cannot be nil.")
      end

      if @management_subnet.nil?
        invalid_properties.push("invalid value for 'management_subnet', management_subnet cannot be nil.")
      end

      if @downlink_subnet.nil?
        invalid_properties.push("invalid value for 'downlink_subnet', downlink_subnet cannot be nil.")
      end

      if @uplink_subnet.nil?
        invalid_properties.push("invalid value for 'uplink_subnet', uplink_subnet cannot be nil.")
      end

      if @availability_zone.nil?
        invalid_properties.push("invalid value for 'availability_zone', availability_zone cannot be nil.")
      end

      return invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @gateway_ha_index.nil?
      return false if @management_subnet.nil?
      return false if @downlink_subnet.nil?
      return false if @uplink_subnet.nil?
      return false if @availability_zone.nil?
      return true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          _self == o._self &&
          _links == o._links &&
          _schema == o._schema &&
          gateway_ha_index == o.gateway_ha_index &&
          management_subnet == o.management_subnet &&
          downlink_subnet == o.downlink_subnet &&
          uplink_subnet == o.uplink_subnet &&
          availability_zone == o.availability_zone
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [_self, _links, _schema, gateway_ha_index, management_subnet, downlink_subnet, uplink_subnet, availability_zone].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map{ |v| _deserialize($1, v) } )
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = NSXT.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map{ |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end

end
