=begin
#NSX API

#VMware NSX REST API

OpenAPI spec version: 1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.3.1

=end

require 'date'

module NSXT

  class ClusterRestoreStatus
    attr_accessor :status

    attr_accessor :step

    # The list of allowed endpoints, based on the current state of the restore process 
    attr_accessor :endpoints

    # Total number of steps in the entire restore process
    attr_accessor :total_steps

    # Timestamp when restore was started in epoch millisecond
    attr_accessor :restore_start_time

    # Timestamp when restore was completed in epoch millisecond
    attr_accessor :restore_end_time

    # Timestamp when backup was initiated in epoch millisecond
    attr_accessor :backup_timestamp

    # Unique id for backup request
    attr_accessor :id

    # Instructions for users to reconcile Restore operations
    attr_accessor :instructions


    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'status' => :'status',
        :'step' => :'step',
        :'endpoints' => :'endpoints',
        :'total_steps' => :'total_steps',
        :'restore_start_time' => :'restore_start_time',
        :'restore_end_time' => :'restore_end_time',
        :'backup_timestamp' => :'backup_timestamp',
        :'id' => :'id',
        :'instructions' => :'instructions'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'status' => :'GlobalRestoreStatus',
        :'step' => :'RestoreStep',
        :'endpoints' => :'Array<ResourceLink>',
        :'total_steps' => :'Integer',
        :'restore_start_time' => :'Integer',
        :'restore_end_time' => :'Integer',
        :'backup_timestamp' => :'Integer',
        :'id' => :'String',
        :'instructions' => :'Array<InstructionInfo>'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}){|(k,v), h| h[k.to_sym] = v}

      if attributes.has_key?(:'status')
        self.status = attributes[:'status']
      end

      if attributes.has_key?(:'step')
        self.step = attributes[:'step']
      end

      if attributes.has_key?(:'endpoints')
        if (value = attributes[:'endpoints']).is_a?(Array)
          self.endpoints = value
        end
      end

      if attributes.has_key?(:'total_steps')
        self.total_steps = attributes[:'total_steps']
      end

      if attributes.has_key?(:'restore_start_time')
        self.restore_start_time = attributes[:'restore_start_time']
      end

      if attributes.has_key?(:'restore_end_time')
        self.restore_end_time = attributes[:'restore_end_time']
      end

      if attributes.has_key?(:'backup_timestamp')
        self.backup_timestamp = attributes[:'backup_timestamp']
      end

      if attributes.has_key?(:'id')
        self.id = attributes[:'id']
      end

      if attributes.has_key?(:'instructions')
        if (value = attributes[:'instructions']).is_a?(Array)
          self.instructions = value
        end
      end

    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      return invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          status == o.status &&
          step == o.step &&
          endpoints == o.endpoints &&
          total_steps == o.total_steps &&
          restore_start_time == o.restore_start_time &&
          restore_end_time == o.restore_end_time &&
          backup_timestamp == o.backup_timestamp &&
          id == o.id &&
          instructions == o.instructions
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [status, step, endpoints, total_steps, restore_start_time, restore_end_time, backup_timestamp, id, instructions].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map{ |v| _deserialize($1, v) } )
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = NSXT.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map{ |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end

end
