=begin
#NSX API

#VMware NSX REST API

OpenAPI spec version: 1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.3.1

=end

require 'date'

module NSXT
  # A shaper that specifies ingress rate properties in Mb/s
  class IngressRateShaper
    attr_accessor :enabled

    attr_accessor :resource_type

    # Average bandwidth in Mb/s
    attr_accessor :average_bandwidth_mbps

    # Peak bandwidth in Mb/s
    attr_accessor :peak_bandwidth_mbps

    # Burst size in bytes
    attr_accessor :burst_size_bytes

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'enabled' => :'enabled',
        :'resource_type' => :'resource_type',
        :'average_bandwidth_mbps' => :'average_bandwidth_mbps',
        :'peak_bandwidth_mbps' => :'peak_bandwidth_mbps',
        :'burst_size_bytes' => :'burst_size_bytes'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'enabled' => :'BOOLEAN',
        :'resource_type' => :'String',
        :'average_bandwidth_mbps' => :'Integer',
        :'peak_bandwidth_mbps' => :'Integer',
        :'burst_size_bytes' => :'Integer'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}){|(k,v), h| h[k.to_sym] = v}

      if attributes.has_key?(:'enabled')
        self.enabled = attributes[:'enabled']
      end

      if attributes.has_key?(:'resource_type')
        self.resource_type = attributes[:'resource_type']
      else
        self.resource_type = "IngressRateShaper"
      end

      if attributes.has_key?(:'average_bandwidth_mbps')
        self.average_bandwidth_mbps = attributes[:'average_bandwidth_mbps']
      else
        self.average_bandwidth_mbps = 0
      end

      if attributes.has_key?(:'peak_bandwidth_mbps')
        self.peak_bandwidth_mbps = attributes[:'peak_bandwidth_mbps']
      else
        self.peak_bandwidth_mbps = 0
      end

      if attributes.has_key?(:'burst_size_bytes')
        self.burst_size_bytes = attributes[:'burst_size_bytes']
      else
        self.burst_size_bytes = 0
      end

    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @enabled.nil?
        invalid_properties.push("invalid value for 'enabled', enabled cannot be nil.")
      end

      if !@average_bandwidth_mbps.nil? && @average_bandwidth_mbps < 0
        invalid_properties.push("invalid value for 'average_bandwidth_mbps', must be greater than or equal to 0.")
      end

      if !@peak_bandwidth_mbps.nil? && @peak_bandwidth_mbps < 0
        invalid_properties.push("invalid value for 'peak_bandwidth_mbps', must be greater than or equal to 0.")
      end

      if !@burst_size_bytes.nil? && @burst_size_bytes < 0
        invalid_properties.push("invalid value for 'burst_size_bytes', must be greater than or equal to 0.")
      end

      return invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @enabled.nil?
      resource_type_validator = EnumAttributeValidator.new('String', ["IngressRateShaper", "IngressBroadcastRateShaper", "EgressRateShaper"])
      return false unless resource_type_validator.valid?(@resource_type)
      return false if !@average_bandwidth_mbps.nil? && @average_bandwidth_mbps < 0
      return false if !@peak_bandwidth_mbps.nil? && @peak_bandwidth_mbps < 0
      return false if !@burst_size_bytes.nil? && @burst_size_bytes < 0
      return true
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] resource_type Object to be assigned
    def resource_type=(resource_type)
      validator = EnumAttributeValidator.new('String', ["IngressRateShaper", "IngressBroadcastRateShaper", "EgressRateShaper"])
      unless validator.valid?(resource_type)
        fail ArgumentError, "invalid value for 'resource_type', must be one of #{validator.allowable_values}."
      end
      @resource_type = resource_type
    end

    # Custom attribute writer method with validation
    # @param [Object] average_bandwidth_mbps Value to be assigned
    def average_bandwidth_mbps=(average_bandwidth_mbps)

      if !average_bandwidth_mbps.nil? && average_bandwidth_mbps < 0
        fail ArgumentError, "invalid value for 'average_bandwidth_mbps', must be greater than or equal to 0."
      end

      @average_bandwidth_mbps = average_bandwidth_mbps
    end

    # Custom attribute writer method with validation
    # @param [Object] peak_bandwidth_mbps Value to be assigned
    def peak_bandwidth_mbps=(peak_bandwidth_mbps)

      if !peak_bandwidth_mbps.nil? && peak_bandwidth_mbps < 0
        fail ArgumentError, "invalid value for 'peak_bandwidth_mbps', must be greater than or equal to 0."
      end

      @peak_bandwidth_mbps = peak_bandwidth_mbps
    end

    # Custom attribute writer method with validation
    # @param [Object] burst_size_bytes Value to be assigned
    def burst_size_bytes=(burst_size_bytes)

      if !burst_size_bytes.nil? && burst_size_bytes < 0
        fail ArgumentError, "invalid value for 'burst_size_bytes', must be greater than or equal to 0."
      end

      @burst_size_bytes = burst_size_bytes
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          enabled == o.enabled &&
          resource_type == o.resource_type &&
          average_bandwidth_mbps == o.average_bandwidth_mbps &&
          peak_bandwidth_mbps == o.peak_bandwidth_mbps &&
          burst_size_bytes == o.burst_size_bytes
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [enabled, resource_type, average_bandwidth_mbps, peak_bandwidth_mbps, burst_size_bytes].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map{ |v| _deserialize($1, v) } )
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = NSXT.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map{ |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end

end
