=begin
#NSX API

#VMware NSX REST API

OpenAPI spec version: 1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.3.1

=end

require 'date'

module NSXT

  class RouteMapSequenceSet
    # As Path Prepending to influence path selection
    attr_accessor :as_path_prepend

    # Either well-known community name or community value in aa:nn(2byte:2byte) format
    attr_accessor :community

    # Weight used to select certain path
    attr_accessor :weight

    # Multi Exit Discriminator (MED)
    attr_accessor :multi_exit_discriminator


    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'as_path_prepend' => :'as_path_prepend',
        :'community' => :'community',
        :'weight' => :'weight',
        :'multi_exit_discriminator' => :'multi_exit_discriminator'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'as_path_prepend' => :'String',
        :'community' => :'String',
        :'weight' => :'Integer',
        :'multi_exit_discriminator' => :'Integer'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}){|(k,v), h| h[k.to_sym] = v}

      if attributes.has_key?(:'as_path_prepend')
        self.as_path_prepend = attributes[:'as_path_prepend']
      end

      if attributes.has_key?(:'community')
        self.community = attributes[:'community']
      end

      if attributes.has_key?(:'weight')
        self.weight = attributes[:'weight']
      end

      if attributes.has_key?(:'multi_exit_discriminator')
        self.multi_exit_discriminator = attributes[:'multi_exit_discriminator']
      end

    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if !@weight.nil? && @weight > 65535
        invalid_properties.push("invalid value for 'weight', must be smaller than or equal to 65535.")
      end

      if !@weight.nil? && @weight < 0
        invalid_properties.push("invalid value for 'weight', must be greater than or equal to 0.")
      end

      if !@multi_exit_discriminator.nil? && @multi_exit_discriminator > 4294967295
        invalid_properties.push("invalid value for 'multi_exit_discriminator', must be smaller than or equal to 4294967295.")
      end

      if !@multi_exit_discriminator.nil? && @multi_exit_discriminator < 0
        invalid_properties.push("invalid value for 'multi_exit_discriminator', must be greater than or equal to 0.")
      end

      return invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if !@weight.nil? && @weight > 65535
      return false if !@weight.nil? && @weight < 0
      return false if !@multi_exit_discriminator.nil? && @multi_exit_discriminator > 4294967295
      return false if !@multi_exit_discriminator.nil? && @multi_exit_discriminator < 0
      return true
    end

    # Custom attribute writer method with validation
    # @param [Object] weight Value to be assigned
    def weight=(weight)

      if !weight.nil? && weight > 65535
        fail ArgumentError, "invalid value for 'weight', must be smaller than or equal to 65535."
      end

      if !weight.nil? && weight < 0
        fail ArgumentError, "invalid value for 'weight', must be greater than or equal to 0."
      end

      @weight = weight
    end

    # Custom attribute writer method with validation
    # @param [Object] multi_exit_discriminator Value to be assigned
    def multi_exit_discriminator=(multi_exit_discriminator)

      if !multi_exit_discriminator.nil? && multi_exit_discriminator > 4294967295
        fail ArgumentError, "invalid value for 'multi_exit_discriminator', must be smaller than or equal to 4294967295."
      end

      if !multi_exit_discriminator.nil? && multi_exit_discriminator < 0
        fail ArgumentError, "invalid value for 'multi_exit_discriminator', must be greater than or equal to 0."
      end

      @multi_exit_discriminator = multi_exit_discriminator
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          as_path_prepend == o.as_path_prepend &&
          community == o.community &&
          weight == o.weight &&
          multi_exit_discriminator == o.multi_exit_discriminator
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [as_path_prepend, community, weight, multi_exit_discriminator].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map{ |v| _deserialize($1, v) } )
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = NSXT.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map{ |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end

end
